--[[    This file is part of PSP Monopoly.

    PSP Monopoly is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    PSP Monopoly is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with PSP Monopoly; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA]]--

delay(1000)
oldpad = Controls.read()
white = Color.new(255, 255, 255)

dofile("danzeffarray.lua")

keys = Image.load("./Danzeff/keys.png")
keys_c = Image.load("./Danzeff/keys_c.png")
keys_s = Image.load("./Danzeff/keys_s.png")
keys_s_c = Image.load("./Danzeff/keys_s_c.png")
nums = Image.load("./Danzeff/nums.png")
nums_c = Image.load("./Danzeff/nums_c.png")
nums_s = Image.load("./Danzeff/nums_s.png")
nums_s_c = Image.load("./Danzeff/nums_s_c.png")

keyopt = 1
selectpad = standletters
stringnum = 1
danzeffopt = keys_s
innerChoice = 1

--background = Image.load("menu.png")
x=65
y=55

name = ""
-- - - - - - - - - - - - - - - - - - - - - -
--Displays the boxes in the correct places and other...
function danzeff()

	--Up/Down/Left/Right
		--Right
	if analogX > 32 and analogY > -40 and analogY < 40 then
		screen:blit(x+106,y+53,danzeffopt,128,64,63,63)
		stringnum = 6
	end
		--Left
	if analogX < -32 and analogY > -40 and analogY < 40 then
		screen:blit(x+0,y+53,danzeffopt,0,64,63,63)
		stringnum = 4
	end
		--Down
	if analogY > 32 and analogX < 40 and analogX > -40 then
		screen:blit(x+53,y+105,danzeffopt,64,128,63,63)
		stringnum = 8
	end
		--Up
	if analogY < -32 and analogX < 40 and analogX >-40 then
		screen:blit(x+53,y+0,danzeffopt,64,0,63,63)
		stringnum = 2
	end
		--Center
	if analogY > -32 and analogY <32 and analogX < 32 and analogX > -32 then
		screen:blit(x+53,y+53,danzeffopt,64,64,63,63)
		stringnum = 5
	end

	--Diagnals
		--Up/Right
	if analogY < -32 and analogX > 40 then
		screen:blit(x+106,y+0,danzeffopt,128,0,63,63)
		stringnum = 3
	end
		--Up/Left
	if analogY < -32 and analogX < -40 then
		screen:blit(x+0,y+0,danzeffopt,0,0,63,63)
		stringnum = 1
	end
		--Down/Right
	if analogY > 32 and analogX > 40 then
		screen:blit(x+106,y+105,danzeffopt,128,128,63,63)
		stringnum = 9
	end
		--Down/Left
	if analogY > 32 and analogX < -40 then
		screen:blit(x+0,y+105,danzeffopt,0,128,63,63)
		stringnum = 7
	end
end

-- - - - - - - - - - - - - - - - - - - - - -
--Returns whether two controller buttons are the same

function compareControllers(controller1, controller2) -- lua adaptation
	if (controller1:square() ~= controller2:square()) then
		return false
	elseif (controller1:triangle() ~= controller2:triangle()) then
		return false
	elseif (controller1:circle() ~= controller2:circle()) then
		return false
	elseif (controller1:cross() ~= controller2:cross()) then
		return false
	elseif (controller1:up() ~= controller2:up()) then
		return false
	elseif (controller1:down() ~= controller2:down()) then
		return false
	elseif (controller1:left() ~= controller2:left()) then
		return false
	elseif (controller1:right() ~= controller2:right()) then
		return false
	elseif (controller1:start() ~= controller2:start()) then
		return false
	elseif (controller1:select() ~= controller2:select()) then
		return false
	elseif (controller1:l() ~= controller2:l()) then
		return false
	elseif (controller1:r() ~= controller2:r()) then
		return false
	end
	return true
end

-- - - - - - - - - - - - - - - - - - - - - -
--Determines what button has been pressed and returns the letter

function Input(pad)

pressed = 1

if (not compareControllers(oldpad, pad)) then
   if pad:cross() or pad:circle() or pad:triangle() or pad:square() then

	 if (pad:triangle()) then innerChoice = 1
	    elseif pad:square() then innerChoice = 2
	    elseif pad:cross() then innerChoice = 3
	    elseif pad:circle() then innerChoice = 4
	 end
   
pressed = string.byte(string.sub(selectpad[stringnum], innerChoice, innerChoice))

   end
end

oldpad = pad

return pressed
end
-- - - - - - - - - - - - - - - - - - - - - -
--Delays in Milliseconds
function delay( milli )
	vs=math.floor(milli/60)
	screen.waitVblankStart( vs )
end
-- - - - - - - - - - - - - - - - - - - - - -
--name
function name_input(playerNum)
if (textString ~= 0 and textString ~= 1 and textString ~= 2) then
	if (textString == 8 or textString == string.byte("\010")) then 
		name = string.sub(name,1,(string.len(name)-1)) 
	elseif (textString == 13) then 
		name = ""
	elseif (textString == 4) then
		return 
	else
		name = name .. string.char(textString)
	end
	
end
end
-- - - - - - - - - - - - - - - - - - - - - -
function clear_ram()
	keys = nil
	keys_c = nil
	keys_s = nil
	keys_s_c = nil
	nums = nil
	nums_c = nil
	nums_s = nil
	nums_s_c = nil
	menuPic = nil
	collectgarbage()
end
-- - - - - - - - - - - - - - - - - - - - - -
while true do
	screen:clear()	
	screen:blit(0,0,menuPic)
	screen:blit(x+10,y+10,keys)
	screen:print(338,140,"Player "..namenum.." Please")
	screen:print(337,150,"Input Your Name")
	screen:print(345,220,"Press Start to")
	screen:print(370,230,"Continue")
	pad = Controls.read()
	analogX = pad:analogX()
	analogY = pad:analogY()
	textString = Input(Controls.read())

name_input(playerName)

if keyopt == 1 then screen:blit(x+10,y+10,keys) danzeffopt = keys_s selectpad = standletters end
if keyopt == 2 then screen:blit(x+10,y+10,keys_c) danzeffopt = keys_s_c selectpad = capletters end
if keyopt == 3 then screen:blit(x+10,y+10,nums) danzeffopt = nums_s selectpad = numbers end
if keyopt == 4 then screen:blit(x+10,y+10,nums_c) danzeffopt = nums_s_c selectpad = specialchar end

if pad:r() then keyopt = keyopt + 1 delay(500) end
if pad:l() then keyopt = keyopt - 1 delay(500) end
if keyopt > 4 then keyopt = 1 end
if keyopt < 1 then keyopt = 4 end

danzeff()
screen:print(3,262,"Name: "..name)

if pad:start() then
	if num == 2 then
		clear_ram()
	end
	pname[namenum] = name
	break
end

screen.waitVblankStart()
screen.flip()
end
