--[[
PSP Monopoly by Cools
(with help from XiGency and LiquiFire)
Copyright (C) 2005-2007 cools, XiGency, & LiquiFire
]]--

--[[This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.]]--

-- - - - - - - - - - - - - - - - - - - - - -
--GameSplash() - intro
function GameSplash()
	splashPic = Image.load("splash.png")
	while true do
		if Controls.read():cross() or Controls.read():start() then splashPic = nil break end
		screen:blit(0,0,splashPic)
		screen:print(3,3,"Public Beta #2", black)
		screen.waitVblankStart()
		screen.flip()
	end
end
-- - - - - -  - - - - - - - - - - - - - - - - - - -
-- Main Menu
function Menu()
delay(1000)
selectedOption = 1

while true do

pad = Controls.read()

if pad:up() then
selectedOption = selectedOption - 1
delay(500)
end

if pad:down() then
selectedOption = selectedOption + 1
delay(500)
end

if selectedOption < 1 then selectedOption = 1 end
if selectedOption > 3 then selectedOption = 3 end

if pad:left() then
	if playerData[selectedOption][playerToken]>1 then
		playerData[selectedOption][playerToken] = playerData[selectedOption][playerToken] - 1
		delay(300)
	end
end

if pad:right() then	
	if playerData[selectedOption][playerToken]<11 then
		playerData[selectedOption][playerToken] = playerData[selectedOption][playerToken] + 1
		delay(300)
	end
end

if pad:start() then
	if playerData[1][playerToken]==playerData[2][playerToken] then message("Cannot have same token.") else collectgarbage() break end
end

if selectedOption==3 then
	if pad:cross() then dofile("savegame.mono") collectgarbage() break end
end

screen:blit(0,0,menuPic)
screen:print(325,50,"Player 1's Token:")
screen:print(325, 150, "Player 2's Token:")
screen:print(365, 250, "Load Game")
if selectedOption==3 then screen:print(345, 220, "Press Cross to ", black)
else screen:print(345, 220, "Press Start to ", black) end
screen:print(370, 230, "Continue", black)
if selectedOption==1 then screen:blit(317,51,square) end
if selectedOption==2 then screen:blit(317,151,square) end
if selectedOption==3 then screen:blit(317,251,square) end

for i=1,2 do
	x=325
	if i==1 then y=70 else y=170 end
	screen:blit(x, y, token[playerData[i][playerToken]])
end

drawMessages()
screen.waitVblankStart()
screen.flip()

end
end
-- - - - - - - - - - - - - - - - - - - -
-- Name Input
function Name_Select(num)
	namenum = num
	if pname[num] == "" then
		dofile("name_select.lua")
	elseif pname[num] ~= "" then return end
end
-- - - - - - - - - - - - - - - - - - - -
-- Main Game Initialization
function Init()
--Colors!
black = Color.new(0, 0, 0)
white = Color.new(255,255,255)
red = Color.new(255,0,0)

-- Load Gfx
monopoly = Image.load("monopolyboardnew.png")
dice = Image.load("dice.png")

--Houses and Hotels
house = Image.load("house.png")
house90 = Image.load("house90.png")
house180 = Image.load("house180.png")
house270 = Image.load("house270.png")
hotel = Image.load("hotel.png")
hotel90 = Image.load("hotel90.png")
hotel180 = Image.load("hotel180.png")
hotel270 = Image.load("hotel270.png")

--Menu Stuff
mortopts = Image.load("Mortopts.png")
selector = Image.load("selector.png")
options = Image.load("Options.png")
square = Image.load("square.png")
menuPic = Image.load("menu.png")

-- Title Deeds
deedMediterranean=Image.load("Title Deeds/Mediterranean Avenue.png")
deedBaltic=Image.load("Title Deeds/Baltic Avenue.png")
deedReadingRR=Image.load("Title Deeds/Reading Railroad.png")
deedOriental=Image.load("Title Deeds/Oriental Avenue.png")
deedVermont=Image.load("Title Deeds/Vermont Avenue.png")
deedConnecticut=Image.load("Title Deeds/Connecticut Avenue.png")
deedCharles=Image.load("Title Deeds/St. Charles Place.png")
deedElectric=Image.load("Title Deeds/Electric Company.png")
deedStates=Image.load("Title Deeds/States Avenue.png")
deedVirginia=Image.load("Title Deeds/Virginia Avenue.png")
deedPennsylvaniaRR=Image.load("Title Deeds/Pennsylvania Railroad.png")
deedJames=Image.load("Title Deeds/St James Place.png")
deedTennessee=Image.load("Title Deeds/Tennessee Avenue.png")
deedNewYork=Image.load("Title Deeds/New York Avenue.png")
deedKentucky=Image.load("Title Deeds/Kentucky Avenue.png")
deedIndiana=Image.load("Title Deeds/Indiana Avenue.png")
deedIllinois=Image.load("Title Deeds/Illinois Avenue.png")
deedBORR=Image.load("Title Deeds/B & O Railroad.png")
deedAtlantic=Image.load("Title Deeds/Atlantic Avenue.png")
deedVentnor=Image.load("Title Deeds/Ventnor Avenue.png")
deedWater=Image.load("Title Deeds/Water Works.png")
deedMarvin=Image.load("Title Deeds/Marvin Gardens.png")
deedPacific=Image.load("Title Deeds/Pacific Avenue.png")
deedCarolina=Image.load("Title Deeds/North Carolina Avenue.png")
deedPennsylvania=Image.load("Title Deeds/Pennsylvania Avenue.png")
deedShortRR=Image.load("Title Deeds/Short Line Railroad.png")
deedPark=Image.load("Title Deeds/Park Place.png")
deedBoardwalk=Image.load("Title Deeds/Boardwalk.png")

-- Community Chest and Chance Cards
dofile("cardData.lua")

-- MiniPics
dofile("MiniPics.lua")

-- Tokens
token = {}
token[1]=Image.load("Tokens/iron.png")
token[2]=Image.load("Tokens/car.png")
token[3]=Image.load("Tokens/thimble.png")
token[4]=Image.load("Tokens/canon.png")
token[5]=Image.load("Tokens/wheelbarow.png")
token[6]=Image.load("Tokens/moneybags.png")
token[7]=Image.load("Tokens/ship.png")
token[8]=Image.load("Tokens/boot.png")
token[9]=Image.load("Tokens/horse.png")
token[10]=Image.load("Tokens/hat.png")
token[11]=Image.load("Tokens/hockey.png")

-- load Sfx
tokenSound = Sound.load("move.wav")
rollSound = Sound.load("roll.wav")
tojail = Sound.load("tojail.wav")

dieWidth = 16
dieHeight = 16
dieOne = 1
dieTwo = 1
numPlayers = 2 	-- 2 players
numSquares = 40
communityCards = 16
chanceCards = 16
turnNum = 1
rolled = 0
doubles = 0
rolled2 = 0
doubles2 = 0

messageText1=""
messageText2=""
messageInfo="Welcome to PSP Monopoly"

-- Array for all data of the players. 1=plyr 2=cp
-- example playerData[1][playerSquare] is the square they're on

-- Constants say what each part of the array is for
playerSquare = 1
playerMoney = 1500
playerToken = 3
playerJail = 0
playerRR = {}
playerRR[1] = 0
playerRR[2] = 0

playerDeed = {}
playerData = {}
for i=1, numPlayers do
playerData[i] = {}
end

-- initialize players stuff (square and money)
for i=1, 2 do
playerData[i][playerSquare] = 1
playerData[i][playerMoney] = 1500
playerData[i][playerJail] = 0
playerData[i][playerToken] = i
end

--GOUJ
oujcomm = 0
oujchan = 0

--Title Data
dofile("titleData.lua")

--Name Data
pname = {}
pname[1] = ""
pname[2] = ""

-- board will have all peices or tokens for each space
board = {}
for i=1, numSquares do
board[i] = {}
end

end
-- - - - - - - - - - - - - - - - - - - - - -
--If even number
function even(num)
	if math.mod(num, 2) == 0 then
		return true
		else return false
	end
end
-- - - - - - - - - - - - - - - 
-- Roll Dice
function rollDice()
	rollSound:play()
	
	for i=1, 10 do
		math.randomseed(os.time())
		dieOne = math.random(6)
		dieTwo = math.random(6)

		screen:clear(black)
		screen:blit(0, 0, monopoly, false)

		screen:print(18, 85,pname[1], black) -- Your Stuff
		screen:blit(3, 82, token[playerData[1][playerToken]])
		screen:print(150, 85,"$"..playerData[1][playerMoney].."", black)

		screen:print(18, 162,pname[2], black) -- Player 2's Stuff
		screen:blit(3, 159, token[playerData[2][playerToken]])
		screen:print(150, 162,"$"..playerData[2][playerMoney].."", black)

		screen:blit(89,60, dice, (dieOne-1)*dieWidth, 0, dieWidth, dieHeight)
		screen:blit(110,60, dice, (dieTwo-1)*dieWidth, 0, dieWidth, dieHeight)
		drawMessages()
		drawPieces()
		displayMiniPic()
		displayHouseHotel()

		screen.flip()
		screen.waitVblankStart( i )
	end

end

-- - - - - - - -  Message function. tells player its their turn, etc
function message( string )
messageText2=messageText1
messageText1=string
end

function drawMessages()
	screen:print(3, 230, messageText1, black)
	screen:print(3, 246, messageText2, black)
	screen:print(3, 262, messageInfo, black)
end

-- - - - - - - - - - - - - - - - - - - - - - - - -
--Displays a Chance Card
function displayChance(num)
	math.randomseed(os.time())
	randomNum = math.random(16)
	ChanceCard = Image.load("./Chance Cards/"..chancePic[randomNum])
	
	playerData[num][playerMoney] = playerData[num][playerMoney] + chance[randomNum]
	
	if randomNum == 2 then
		playerData[num][playerSquare] = 40
	end
	
	if randomNum == 4 then
		if num == 1 then
			playerData[1][playerMoney] = playerData[1][playerMoney] - 50
			playerData[2][playerMoney] = playerData[2][playerMoney] + 50
		end
		if num == 2 then
			playerData[2][playerMoney] = playerData[2][playerMoney] - 50
			playerData[1][playerMoney] = playerData[1][playerMoney] + 50
		end
	end
	
	if randomNum == 5 then
		-- playerData[1][playerMoney] = playerData[1][playerMoney] - ((playerData[1][playerHouse] * 25) +(playerData[1][playerHotel] * 100)
	end
	
	if randomNum == 6 then
		playerData[num][playerSquare] = 1
	end
	
	if randomNum == 7 then
		playerData[num][playerSquare] = 11
		playerData[num][playerJail] = 1
	end
	
	if randomNum == 8 then
		playerData[num][playerSquare] = 25
	end
	
	if randomNum == 9 then
		if oujchan == 0 then
			oujchan = num
		end
	end

	if randomNum == 12 then
		playerData[num][playerSquare] = 16
	end
	
	if randomNum == 14 then
		playerData[num][playerSquare] = 12
	end
	
	while true do
		screen:blit(247,80,ChanceCard)
		screen.flip()
		drawMessages()
		drawPieces()
		displayMiniPic()
		displayHouseHotel()		
		delay(6000)
		break
	end
	ChanceCard = nil
	collectgarbage()
end

-- - - - - - - - - - - - - - - - - - - - - -
--Displays a Community Chest Card
function displayCommunity(num)
	math.randomseed(os.time())
	randomNum = math.random(16)
	CommunityCard = Image.load("./Community Chest/"..communityPic[randomNum])

	playerData[num][playerMoney] = playerData[num][playerMoney] + community[randomNum]

	if randomNum == 1 then
		if num == 1 then
			playerData[1][playerMoney] = round(playerData[2][playerMoney]*.1) + playerData[1][playerMoney]
			playerData[2][playerMoney] = playerData[2][playerMoney] - round(playerData[2][playerMoney]*.1)
		end
		if num == 2 then
			playerData[2][playerMoney] = round(playerData[1][playerMoney]*.1) + playerData[2][playerMoney]
			playerData[1][playerMoney] = playerData[1][playerMoney] - round(playerData[1][playerMoney]*.1)
		end
	end

	if randomNum == 4 then --Get out of Jail Free...
		if oujcomm == 0 then
			oujcomm = num
		end
	end

	if randomNum == 6 then
		playerData[num][playerSquare] = 1
	end

	if randomNum == 7 then
		playerData[num][playerSquare] = 11
		playerData[num][playerJail] = 1
	end

	if randomNum == 11 then
		playerData[num][playerSquare] = 6
	end

	if randomNum == 12 then
		if num == 1 then
			playerData[2][playerMoney] = playerData[2][playerMoney] - 50
			playerData[1][playerMoney] = playerData[1][playerMoney] + 50
		end
		if num == 2 then
			playerData[1][playerMoney] = playerData[1][playerMoney] - 50
			playerData[2][playerMoney] = playerData[2][playerMoney] + 50
		end
	end

	while true do
		screen:blit(247,80,CommunityCard)
		screen.flip()
		drawMessages()
		drawPieces()
		displayMiniPic()
		displayHouseHotel()	
		delay(4000)
		break
	end
	CommunityCard = nil
	collectgarbage()
end
-- - - - - - - - - - - - - - - - - - - - - - - -
-- delay function. delays in milliseconds
function delay( milli )
	vs=math.floor(milli/60)
	screen.waitVblankStart( vs )
end
-- - - - - - - - - - - - - - - - - - - - - - - -
-- drawPieces()
function drawPieces()

	for i=1, 2 do
		sq=playerData[i][playerSquare]
		if sq<12 then 	--230 to 464, 11 squares, 234/11 = 21.2
			x=230+(11-sq)*22
			y=235+i*12
		end

		if sq<22 and sq>11 then 	--0 to 220, 11 squares, 220/11 = -2-0- (22)
			x=200+i*12
			y=15+(21-sq)*22
		end

		if sq<32 and sq>21 then 	--230 to 464, 11 squares, 234/11 = 21.2
			x=230+(sq-21)*22
			y=i*12-12
		end

		if sq<41 and sq>31 then 	--0 to 272, 11 squares, 272/11 = 24.7  (22)
			x=443+i*12
			y=15+(sq-31)*22
		end

		if sq==11 then
			if playerData[i][playerJail]>0 then
				x=208+i*12
				y=242
			else
				x=210
				y=225+i*12
			end
		end

		screen:blit(x, y, token[playerData[i][playerToken]])
end
for i=1, 2 do
		if playerData[i][playerSquare]==2 then screen:blit(247, 37, deedMediterranean) end
		if playerData[i][playerSquare]==4 then screen:blit(247, 37, deedBaltic) end
		if playerData[i][playerSquare]==6 then screen:blit(247, 37, deedReadingRR) end
		if playerData[i][playerSquare]==7 then screen:blit(247, 37, deedOriental) end
		if playerData[i][playerSquare]==9 then screen:blit(247, 37, deedVermont) end
		if playerData[i][playerSquare]==10 then screen:blit(247, 37, deedConnecticut) end
		if playerData[i][playerSquare]==12 then screen:blit(247, 37, deedCharles) end
		if playerData[i][playerSquare]==13 then screen:blit(247, 37, deedElectric) end
		if playerData[i][playerSquare]==14 then screen:blit(247, 37, deedStates) end
		if playerData[i][playerSquare]==15 then screen:blit(247, 37, deedVirginia) end
		if playerData[i][playerSquare]==16 then screen:blit(247, 37, deedPennsylvaniaRR) end
		if playerData[i][playerSquare]==17 then screen:blit(247, 37, deedJames) end
		if playerData[i][playerSquare]==19 then screen:blit(247, 37, deedTennessee) end
		if playerData[i][playerSquare]==20 then screen:blit(247, 37, deedNewYork) end
		if playerData[i][playerSquare]==22 then screen:blit(247, 37, deedKentucky) end
		if playerData[i][playerSquare]==24 then screen:blit(247, 37, deedIndiana) end
		if playerData[i][playerSquare]==25 then screen:blit(247, 37, deedIllinois) end
		if playerData[i][playerSquare]==26 then screen:blit(247, 37, deedBORR) end
		if playerData[i][playerSquare]==27 then screen:blit(247, 37, deedAtlantic) end
		if playerData[i][playerSquare]==28 then screen:blit(247, 37, deedVentnor) end
		if playerData[i][playerSquare]==29 then screen:blit(247, 37, deedWater) end
		if playerData[i][playerSquare]==30 then screen:blit(247, 37, deedMarvin) end
		if playerData[i][playerSquare]==32 then screen:blit(247, 37, deedPacific) end
		if playerData[i][playerSquare]==33 then screen:blit(247, 37, deedCarolina) end
		if playerData[i][playerSquare]==35 then screen:blit(247, 37, deedPennsylvania) end
		if playerData[i][playerSquare]==36 then screen:blit(247, 37, deedShortRR) end
		if playerData[i][playerSquare]==38 then screen:blit(247, 37, deedPark) end
		if playerData[i][playerSquare]==40 then screen:blit(247, 37, deedBoardwalk) end
	end
end
----  - - - - - - - - - - - - - - - - - - - - - - - - - -
-- displayMiniPic
function displayMiniPic()

if deed[14][2]==1 then screen:blit(13, 135, miniMediterranean) end
if deed[14][4]==1 then screen:blit(9, 131, miniBaltic) end
if deed[14][6]==1 then screen:blit(76, 112, miniRR) end
if deed[14][7]==1 then screen:blit(40, 137, miniOriental) end
if deed[14][9]==1 then screen:blit(36, 133, miniVermont) end
if deed[14][10]==1 then screen:blit(32, 129, miniConnecticut) end
if deed[14][12]==1 then screen:blit(65, 137, miniCharles) end
if deed[14][13]==1 then screen:blit(143, 111, miniElectric) end
if deed[14][14]==1 then screen:blit(61, 133, miniStates) end
if deed[14][15]==1 then screen:blit(57, 129, miniVirginia) end
if deed[14][16]==1 then screen:blit(92, 112, miniRR) end
if deed[14][17]==1 then screen:blit(90, 137, miniJames) end
if deed[14][19]==1 then screen:blit(86, 133, miniTennessee) end
if deed[14][20]==1 then screen:blit(82, 129, miniNewYork) end
if deed[14][22]==1 then screen:blit(115, 137, miniKentucky) end
if deed[14][24]==1 then screen:blit(111, 133, miniIndiana) end
if deed[14][25]==1 then screen:blit(107, 129, miniIllinois) end
if deed[14][26]==1 then screen:blit(108, 112, miniRR) end
if deed[14][27]==1 then screen:blit(140, 137, miniAtlantic) end
if deed[14][28]==1 then screen:blit(136, 133, miniVentnor) end
if deed[14][29]==1 then screen:blit(155, 112, miniWater) end
if deed[14][30]==1 then screen:blit(132, 129, miniMarvin) end
if deed[14][32]==1 then screen:blit(165, 137, miniPacific) end
if deed[14][33]==1 then screen:blit(161, 133, miniCarolina) end
if deed[14][35]==1 then screen:blit(157, 129, miniPennsylvania) end
if deed[14][36]==1 then screen:blit(124, 112, miniRR) end
if deed[14][38]==1 then screen:blit(187, 135, miniPark) end
if deed[14][40]==1 then screen:blit(184, 131, miniBoardwalk) end
if oujcomm == 1 then screen:blit(60, 115, miniCommOUJ) end
if oujchan == 1 then screen:blit(44, 115, miniChanOUJ) end

if deed[14][2]==2 then screen:blit(13, 202, miniMediterranean) end
if deed[14][4]==2 then screen:blit(9, 198, miniBaltic) end
if deed[14][6]==2 then screen:blit(76, 179, miniRR) end
if deed[14][7]==2 then screen:blit(40, 204, miniOriental) end
if deed[14][9]==2 then screen:blit(36, 200, miniVermont) end
if deed[14][10]==2 then screen:blit(32, 196, miniConnecticut) end
if deed[14][12]==2 then screen:blit(65, 204, miniCharles) end
if deed[14][13]==2 then screen:blit(143, 178, miniElectric) end
if deed[14][14]==2 then screen:blit(61, 200, miniStates) end
if deed[14][15]==2 then screen:blit(57, 196, miniVirginia) end
if deed[14][16]==2 then screen:blit(92, 179, miniRR) end
if deed[14][17]==2 then screen:blit(90, 204, miniJames) end
if deed[14][19]==2 then screen:blit(86, 200, miniTennessee) end
if deed[14][20]==2 then screen:blit(82, 196, miniNewYork) end
if deed[14][22]==2 then screen:blit(115, 204, miniKentucky) end
if deed[14][24]==2 then screen:blit(111, 200, miniIndiana) end
if deed[14][25]==2 then screen:blit(107, 196, miniIllinois) end
if deed[14][26]==2 then screen:blit(108, 179, miniRR) end
if deed[14][27]==2 then screen:blit(140, 204, miniAtlantic) end
if deed[14][28]==2 then screen:blit(136, 200, miniVentnor) end
if deed[14][29]==2 then screen:blit(155, 179, miniWater) end
if deed[14][30]==2 then screen:blit(132, 196, miniMarvin) end
if deed[14][32]==2 then screen:blit(165, 204, miniPacific) end
if deed[14][33]==2 then screen:blit(161, 200, miniCarolina) end
if deed[14][35]==2 then screen:blit(157, 196, miniPennsylvania) end
if deed[14][36]==2 then screen:blit(124, 179, miniRR) end
if deed[14][38]==2 then screen:blit(187, 202, miniPark) end
if deed[14][40]==2 then screen:blit(184, 198, miniBoardwalk) end
if oujcomm == 2 then screen:blit(60, 182, miniCommOUJ) end
if oujchan == 2 then screen:blit(44, 182, miniChanOUJ) end

end
----  - - - - - - - - - - - - - - - - - - - - - - - - - -
-- display House or Hotel
function displayHouseHotel()

for r = 2, 10 do
if deed[13][r] >= 1 and deed[13][r] < 5 then screen:blit(241+(11-r)*22, 237, house) end
if deed[13][r] >= 2 and deed[13][r] < 5 then screen:blit(236+(11-r)*22, 237, house) end
if deed[13][r] >= 3 and deed[13][r] < 5 then screen:blit(231+(11-r)*22, 237, house) end
if deed[13][r] >= 4 and deed[13][r] < 5 then screen:blit(226+(11-r)*22, 237, house) end
if deed[13][r] == 5 then screen:blit(232+(11-r)*22, 237, hotel) end
end

for p = 12, 20 do
if deed[13][p] >= 1 and deed[13][p] < 5 then screen:blit(240, 31+(21-p)*22, house90) end
if deed[13][p] >= 2 and deed[13][p] < 5 then screen:blit(240, 26+(21-p)*22, house90) end
if deed[13][p] >= 3 and deed[13][p] < 5 then screen:blit(240, 21+(21-p)*22, house90) end
if deed[13][p] >= 4 and deed[13][p] < 5 then screen:blit(240, 16+(21-p)*22, house90) end
if deed[13][p] == 5 then screen:blit(240, 22+(21-p)*22, hotel90) end
end

for t = 22, 30 do
if deed[13][t] >= 1 and deed[13][t] < 5 then screen:blit(226+(t-21)*22, 29, house180) end
if deed[13][t] >= 2 and deed[13][t] < 5 then screen:blit(231+(t-21)*22, 29, house180) end
if deed[13][t] >= 3 and deed[13][t] < 5 then screen:blit(236+(t-21)*22, 29, house180) end
if deed[13][t] >= 4 and deed[13][t] < 5 then screen:blit(241+(t-21)*22, 29, house180) end
if deed[13][t] == 5 then if t < 26 and t > 21 then screen:blit(232+(t-21)*22, 29, hotel180, false)
else screen:blit(232+(t-21)*22, 29, hotel180) end end
end

for n = 32, 40 do
if deed[13][n] >= 1 and deed[13][n] < 5 then screen:blit(446, 17+(n-31)*22, house270) end
if deed[13][n] >= 2 and deed[13][n] < 5 then screen:blit(446, 22+(n-31)*22, house270) end
if deed[13][n] >= 3 and deed[13][n] < 5 then screen:blit(446, 27+(n-31)*22, house270) end
if deed[13][n] >= 4 and deed[13][n] < 5 then screen:blit(446, 32+(n-31)*22, house270) end
if deed[13][n] == 5 then screen:blit(446, 23+(n-31)*22, hotel270) end
end

end
----  - - - - - - - - - - - - - - - - - - - - - - - - - -
--Round #
function round(num)
	if (num-math.floor(num))<0.5 then
		return(math.floor(num))
	else
		return(math.ceil(num))
	end
end -- Thanks Magician FB!
----  - - - - - - - - - - - - - - - - - - - - - - - - - -
-- movePlayer( player#, spaces)
function movePlayer(num, spaces)

if playerData[num][playerJail]==0 then

for i=1, spaces do
tokenSound:play()
playerData[num][playerSquare]=playerData[num][playerSquare]+1 -- Move Player

--display Messages
if num == 1 then
	if deed[14][playerData[1][playerSquare]]==2 then
		messageText1 ="You landed on "..deed[12][playerData[num][playerSquare]]..""
		messageText2 = "Player 2 Owns this property"
		messageInfo = "Press Square to Pay Rent"
	end

	if deed[14][playerData[1][playerSquare]]==1 then
		messageText1 ="You landed on "..deed[12][playerData[1][playerSquare]]..""
		messageText2 = "You Own this property"
		messageInfo = "Press Start to end your turn"
	end
end

if num == 2 then
	if deed[14][playerData[2][playerSquare]]==1 then
		messageText1 ="You landed on "..deed[12][playerData[num][playerSquare]]..""
		messageText2 = "Player 1 Owns this property"
		messageInfo = "Press Square to Pay Rent"
	end

	if deed[14][playerData[2][playerSquare]]==2 then
		messageText1 ="You landed on "..deed[12][playerData[2][playerSquare]]..""
		messageText2 = "You Own this property"
		messageInfo = "Press Start to end your turn"
	end
end

if deed[14][playerData[num][playerSquare]]==0 then
messageText1 ="You landed on "..deed[12][playerData[num][playerSquare]]..""
messageText2 = "Press Square to buy for $"..deed[2][playerData[num][playerSquare]]..""
messageInfo = "Press Triangle to Auction"
end

if deed[14][playerData[num][playerSquare]]==3 then
messageText1 ="You landed on "..deed[12][playerData[num][playerSquare]]..""
messageText2 = "This property is Mortgaged"
messageInfo = "Press Start to end your turn"
end

if deed[0][playerData[num][playerSquare]]==2 then
messageText1="You landed on Chance"
messageText2="Press Circle to see your card"
messageInfo="Press Start to end your turn"
end

if deed[0][playerData[num][playerSquare]]==3 then
messageText1="You landed on Community Chest"
messageText2="Press Circle to see your card"
messageInfo="Press Start to end your turn"
end

if playerData[num][playerSquare]==1 then
	messageText1="You are on Go"
	messageText2="Collect $200"
	messageInfo="Press Start to end your turn"
end

if playerData[num][playerSquare]==5 then
messageText1="You landed on Income Tax"
messageText2="Press Square to Pay 200 or "
messageInfo="Triangle to Pay 10%"
end

if playerData[num][playerSquare]==11 then
messageText1="Just Visiting Jail"
messageText2="Press Start to end your turn"
messageInfo=""
end

if playerData[num][playerSquare]==21 then
messageText1="You landed on Free Parking"
messageText2=""
messageInfo="Press Start to end your turn"
end

if playerData[num][playerSquare]==39 then
messageText1="You landed on Luxury Tax"
messageText2="Press Circle to pay $75"
messageInfo="Press Start to end your turn"
end

if playerData[num][playerSquare]>40 then -- Go, add $200
playerData[num][playerSquare]=1
playerData[num][playerMoney]=playerData[num][playerMoney]+200
end

screen:blit(0, 0, monopoly)

screen:print(18, 85,pname[1], black) -- Your Stuff
screen:blit(3, 82, token[playerData[1][playerToken]])
screen:print(150, 85,"$"..playerData[1][playerMoney].."", black)

screen:print(18, 162,pname[2], black) -- Player 2's Stuff
screen:blit(3, 159, token[playerData[2][playerToken]])
screen:print(150, 162,"$"..playerData[2][playerMoney].."", black)

screen:blit(89,60, dice, (dieOne-1)*dieWidth, 0, dieWidth, dieHeight)
screen:blit(110,60, dice, (dieTwo-1)*dieWidth, 0, dieWidth, dieHeight)

drawMessages()
drawPieces()
displayMiniPic()
displayHouseHotel()

screen.waitVblankStart()
screen.flip()
delay( 700 )

end
else
playerData[num][playerJail]=playerData[num][playerJail]-1;
end

if playerData[num][playerSquare]==31 then
	if playerData[num][playerSquare]==31 then
		messageText1="Go To Jail. Do Not Pass Go"
		messageText2="Do Not Collect $200"
		tojail:play()
	end
	playerData[num][playerSquare]=11
	playerData[num][playerJail]=1
end

if deed[0][playerData[num][playerSquare]] == 0 then
	if deed[1][playerData[num][playerSquare]] == 0 then
		BuyDeed(num)
	else
		PayDeed(num)
	end
end

if playerData[num][playerSquare]==39 then --Luxury Tax
	if num==1 or num == 2 then
		a0004uk=nicefind
		while true do
			pad = Controls.read()
			if pad:circle() then
				playerData[num][playerMoney] = playerData[num][playerMoney] - 75
				break
			end
		end
	end
end

if playerData[num][playerSquare]==5 then --Income Tax
	if num==1 or num == 2 then
		run=fast
		while true do
			pad = Controls.read()
			if pad:square() then
				playerData[num][playerMoney] = playerData[num][playerMoney] - 200
				break
			end
			if pad:triangle() then
				playerData[num][playerMoney] = playerData[num][playerMoney] - round(playerData[num][playerMoney]*.1)
				break
			end
		end
	end
end

end
----  - - - - - - - - - - - - - - - - - - - - - - - - - -
--Buy Deed
function BuyDeed(num)
	if num==1 or num == 2 then
		while true do
			pad = Controls.read()
			if pad:triangle() then Auction(num) end
			if pad:square() then
				playerData[num][playerMoney] = playerData[num][playerMoney] - deed[2][playerData[num][playerSquare]]
				deed[1][playerData[num][playerSquare]] = 1
				deed[14][playerData[num][playerSquare]] = num
				table.insert(deed[14 + num],playerData[num][playerSquare])
				
				if playerData[1][playerSquare] == 6 or playerData[1][playerSquare] == 16 or playerData[1][playerSquare] == 26 or playerData[1][playerSquare] == 36 then
					if playerRR[num] ~= 0 then playerRR[num] = playerRR[num] * 2 else
						playerRR[num] = 1
					end
				end

				break
			end
		end
	end
end
----  - - - - - - - - - - - - - - - - - - - - - - - - - -
--Pay Deed
function PayDeed(num)
	if num==1 then
		while true do
			if Controls.read():square() then
				if deed[14][playerData[1][playerSquare]] == 2 then

					if playerData[num][playerSquare] == 6 or playerData[num][playerSquare] == 16 or playerData[num][playerSquare] == 26 or playerData[num][playerSquare] == 36 then
						if deed[14][playerData[num][playerSquare]] == 2 then
							playerData[num][playerMoney] = playerData[num][playerMoney] - playerRR[2] * 25
							playerData[2][playerMoney] = playerData[2][playerMoney] + playerRR[2] * 25
						end
					end

					if playerData[num][playerSquare] == 13 and deed[14][13] == 2 and deed[14][29] == 2 then
						playerData[num][playerMoney] = playerData[num][playerMoney] - (dieOne + dieTwo) * 12
						playerData[2][playerMoney] = playerData[2][playerMoney] + (dieOne + dieTwo) * 12
					end

					if playerData[num][playerSquare] == 13 and deed[14][13] == 2 and deed[14][29] ~= 2 then
						playerData[num][playerMoney] = playerData[num][playerMoney] - (dieOne + dieTwo) * 4
						playerData[2][playerMoney] = playerData[2][playerMoney] + (dieOne + dieTwo) * 4
					end

					if playerData[num][playerSquare] == 29 and deed[14][13] == 2 and deed[14][29] == 2 then
						playerData[num][playerMoney] = playerData[num][playerMoney] - (dieOne + dieTwo) * 12
						playerData[2][playerMoney] = playerData[2][playerMoney] + (dieOne + dieTwo) * 12
					end

					if playerData[num][playerSquare] == 29 and deed[14][29] == 2 and deed[14][13] ~= 2 then
						playerData[num][playerMoney] = playerData[num][playerMoney] - (dieOne + dieTwo) * 4
						playerData[2][playerMoney] = playerData[2][playerMoney] + (dieOne + dieTwo) * 4
					end

					for numd = 0, 5 do
						if deed[13][playerData[num][playerSquare]] == numd then
							playerData[num][playerMoney] = playerData[num][playerMoney] - deed[numd + 3][playerData[num][playerSquare]]
							playerData[2][playerMoney] = playerData[2][playerMoney] + deed[numd + 3][playerData[num][playerSquare]]
						end
					end
		break
				elseif deed[14][playerData[num][playerSquare]] == 1 then -- if you own it then u dont have to pay
					break
					
				elseif deed[14][playerData[num][playerSquare]] == 3 then --If mortgaged then dont pay
					break	
				end
			end
		end
	end

	if num==2 then
		while true do	
			if Controls.read():square() then
				if deed[14][playerData[num][playerSquare]] == 1 then

					if playerData[num][playerSquare] == 6 or playerData[num][playerSquare] == 16 or playerData[num][playerSquare] == 26 or playerData[num][playerSquare] == 36 then
						if deed[14][playerData[num][playerSquare]] == 1 then
							playerData[num][playerMoney] = playerData[num][playerMoney] - playerRR[1] * 25
							playerData[1][playerMoney] = playerData[1][playerMoney] + playerRR[1] * 25
						end
					end

					if playerData[num][playerSquare] == 13 and deed[14][13] == 1 and deed[14][29] == 1 then
						playerData[num][playerMoney] = playerData[num][playerMoney] - (dieOne + dieTwo) * 12
						playerData[1][playerMoney] = playerData[1][playerMoney] + (dieOne + dieTwo) * 12
					end

					if playerData[num][playerSquare] == 13 and deed[14][13] == 1 and deed[14][29] ~= 1 then
						playerData[num][playerMoney] = playerData[num][playerMoney] - (dieOne + dieTwo) * 4
						playerData[1][playerMoney] = playerData[1][playerMoney] + (dieOne + dieTwo) * 4
					end

					if playerData[num][playerSquare] == 29 and deed[14][13] == 1 and deed[14][29] == 1 then
						playerData[num][playerMoney] = playerData[num][playerMoney] - (dieOne + dieTwo) * 12
						playerData[1][playerMoney] = playerData[1][playerMoney] + (dieOne + dieTwo) * 12
					end

					if playerData[num][playerSquare] == 29 and deed[14][29] == 1 and deed[14][13] ~= 1 then
						playerData[num][playerMoney] = playerData[num][playerMoney] - (dieOne + dieTwo) * 4
						playerData[1][playerMoney] = playerData[1][playerMoney] + (dieOne + dieTwo) * 4
					end

					for dnum = 0, 5 do
						if deed[13][playerData[num][playerSquare]] == dnum then
							playerData[num][playerMoney] = playerData[num][playerMoney] - deed[dnum + 3][playerData[num][playerSquare]]
							playerData[1][playerMoney] = playerData[1][playerMoney] + deed[dnum + 3][playerData[num][playerSquare]]
						end
					end
		break
				elseif deed[14][playerData[num][playerSquare]] == 2 then --if comp owns it then comp dont have to pay
					break
					
				elseif deed[14][playerData[num][playerSquare]] == 3 then --if mortgaged then dont pay
					break
				end
			end
		end
	end
end
----  - - - - - - - - - - - - - - - - - - - - - - - - - -
--Auction
function Auction(num)
end
----  - - - - - - - - - - - - - - - - - - - - - - - - - -
--Option Menu
function opmenu(num)
oldpad = Controls.read()
dateFields = os.date("*t", os.time())
hour = dateFields.hour
	if hour < 10 then
		hour = "0" .. hour
	end
	if hour > 12 then
		hour = hour - 12
	elseif hour < 12 then hour = hour
	end
	
min = dateFields.min
	if min < 10 then
		min = "0" .. min
	end

Option = 1

while true do
pad=Controls.read()

if pad ~= oldpad then
	if pad:down() then Option = Option + 1 end
	if pad:up() then Option = Option - 1 end
end

if Option < 1 then Option = 5 end
if Option > 5 then Option = 1 end

if pad:select() then break end

screen:blit(110,60,options)

if Option == 1 then screen:blit(133,87,selector,true) end
if Option == 2 then screen:blit(133,111,selector,true) end
if Option == 3 then screen:blit(133,135,selector,true) end
if Option == 4 then screen:blit(133,159,selector,true) end
if Option == 5 then screen:blit(133,183,selector,true) end

if Option == 1 then if pad:cross() then BuildHouseHotel(num) end end
if Option == 2 then if pad:cross() then delay(500) MortgageOptions(num) end end
if Option == 3 then if pad:cross() then TradeDeeds(num) end end
if Option == 4 then if pad:cross() then SaveGame() end end
if Option == 5 then if pad:cross() then QuitGame() end end

screen:print(3, 1, "Power:"..System.powerGetBatteryLifePercent() .."%", black)
screen:print(128, 1, hour .. ":" .. min, black)

screen.waitVblankStart()
screen.flip()
oldpad = pad
end

end
----  - - - - - - - - - - - - - - - - - - - - - - - - - -
--Build House or Hotel
function BuildHouseHotel(num)
	House_HotelCheck(num)
	houseopt = 1
	select = 0
	oldpad = Controls.read()
	math.randomseed(os.time())
	propnum3 = math.random(1,3)
	propnum2 = math.random(1,2)
	while true do
		screen:clear(white)
		pad = Controls.read()
		if table.getn(deed[19]) ~= 0 then
			if oldpad ~= pad then
				if pad:up() then houseopt = houseopt - 1 end
				if pad:down() then houseopt = houseopt + 1 end
			end
			if houseopt > table.getn(deed[19]) then houseopt = 1 end
			if houseopt < 1 then houseopt = table.getn(deed[19]) end
			for i = 1, table.getn(deed[19]) do
				screen:print(10,i*10,deed[19][i].." Properties",black)			
			end
			if pad:select() then if table.getn(deed[19]) ~= 0 then
				for q = 1, table.getn(deed[19]) do
					table.remove(deed[19],q)
				end
			else break end end

			if deed[19][houseopt] == "Dark Purple" then
				if propnum2 == 1 then select = 2 end
				if propnum2 == 2 then select = 4 end
				if select == 2 then
					if deed[13][select] == 5 then select = 4 end
				end
				if select == 4 then
					if deed[13][select] == 5 then select = 2 end
				end
			end
			if deed[19][houseopt] == "Light Blue" then
				if propnum3 == 1 then select = 7 end
				if propnum3 == 2 then select = 9 end
				if propnum3 == 3 then select = 10 end
					if select == 7 then
					if deed[13][select] == 5 then select = 9 end
				end
				if select == 9 then
					if deed[13][select] == 5 then select = 10 end
				end
				if select == 10 then
					if deed[13][select] == 5 then select = 7 end
				end
			end
			if deed[19][houseopt] == "Purple" then
				if propnum3 == 1 then select = 12 end
				if propnum3 == 2 then select = 14 end
				if propnum3 == 3 then select = 15 end
				if select == 12 then
					if deed[13][select] == 5 then select = 14 end
				end
				if select == 14 then
					if deed[13][select] == 5 then select = 15 end
				end
				if select == 15 then
					if deed[13][select] == 5 then select = 12 end
				end
			end
			if deed[19][houseopt] == "Orange" then
				if propnum3 == 1 then select = 17 end
				if propnum3 == 2 then select = 19 end
				if propnum3 == 3 then select = 20 end
				if select == 17 then
					if deed[13][select] == 5 then select = 19 end
				end
				if select == 19 then
					if deed[13][select] == 5 then select = 20 end
				end
				if select == 20 then
					if deed[13][select] == 5 then select = 17 end
				end
			end
			if deed[19][houseopt] == "Red" then
				if propnum3 == 1 then select = 22 end
				if propnum3 == 2 then select = 24 end
				if propnum3 == 3 then select = 25 end
				if select == 22 then
					if deed[13][select] == 5 then select = 24 end
				end
				if select == 24 then
					if deed[13][select] == 5 then select = 25 end
				end
				if select == 25 then
					if deed[13][select] == 5 then select = 22 end
				end
			end
			if deed[19][houseopt] == "Yellow" then
				if propnum3 == 1 then select = 27 end
				if propnum3 == 2 then select = 28 end
				if propnum3 == 3 then select = 30 end
				if select == 27 then
					if deed[13][select] == 5 then select = 29 end
				end
				if select == 28 then
					if deed[13][select] == 5 then select = 30 end
				end
				if select == 30 then
					if deed[13][select] == 5 then select = 27 end
				end
			end
			if deed[19][houseopt] == "Green" then
				if propnum3 == 1 then select = 32 end
				if propnum3 == 2 then select = 33 end
				if propnum3 == 3 then select = 35 end
				if select == 32 then
					if deed[13][select] == 5 then select = 33 end
				end
				if select == 33 then
					if deed[13][select] == 5 then select = 35 end
				end
				if select == 35 then
					if deed[13][select] == 5 then select = 32 end
				end
			end
			if deed[19][houseopt] == "Dark Blue" then
				if propnum2 == 1 then select = 38 end
				if propnum2 == 2 then select = 40 end
				if select == 38 then
					if deed[13][select] == 5 then select = 40 end
				end
				if select == 40 then
					if deed[13][select] == 5 then select = 38 end
				end
			end

			if oldpad ~= pad then
				if pad:cross() then
					deed[13][select] = deed[13][select] + 1
					if deed[13][select] > 5 then deed[13][select] = 5 end
					if deed[13][select] == 5 then
						playerData[num][playerMoney] = playerData[num][playerMoney]
						else playerData[num][playerMoney] = playerData[num][playerMoney] - deed[9][select]
					end
				end
			end
			if deed[13][select] < 5 and deed[13][select] > 1 then
				screen:print(3,80,"You Have "..deed[13][select].." Houses on this Property")
				elseif deed[13][select] == 1 then
					screen:print(3,80,"You Have "..deed[13][select].." House on this Property")
				elseif deed[13][select] == 0 then
					screen:print(3,80,"You Have NO Houses/Hotels on this Property")
				else
					screen:print(3,80,"You Have a Hotel on this Property")
			end
			screen:print(3,90,"It costs $"..deed[9][select].." for a House or Hotel")
			screen:print(3,0,"Build House/Hotel on:",black)
			screen:print(3,100,"You are currently buying a House/Hotel on "..deed[12][select])
			screen:print(3,110,"Cash: $"..playerData[num][playerMoney])
			screen:blit(3,houseopt*10+2,square)
		else
			screen:print(3,0,"You Can't Buy a House or Hotel!")
		end
		screen.waitVblankStart()
		screen.flip()
		if pad:select() then break end
		oldpad = pad
	end
end
----  - - - - - - - - - - - - - - - - - - - - - - - - - -
--Check for Houses/Hotels if buildable
function House_HotelCheck(num)
	if deed[14][2] == num and deed[14][4] == num then
		table.insert(deed[19],"Dark Purple")
	end
	if deed[14][7] == num and deed[14][9] == num and deed[14][10] == num then
		table.insert(deed[19],"Light Blue")
	end
	if deed[14][12] == num and deed[14][14] == num and deed[14][15] == num then
		table.insert(deed[19],"Purple")
	end
	if deed[14][17] == num and deed[14][19] == num and deed[14][20] == num then
		table.insert(deed[19],"Orange")
	end
	if deed[14][22] == num and deed[14][24] == num and deed[14][25] == num then
		table.insert(deed[19],"Red")
	end
	if deed[14][27] == num and deed[14][28] == num and deed[14][30] == num then
		table.insert(deed[19],"Yellow")
	end
	if deed[14][32] == num and deed[14][33] == num and deed[14][35] == num then
		table.insert(deed[19],"Green")
	end
	if deed[14][38] == num and deed[14][40] == num then
		table.insert(deed[19],"Dark Blue")
	end
end
----  - - - - - - - - - - - - - - - - - - - - - - - - - -
--Mortgage Options
function MortgageOptions(num)
	mortgopts=1
	oldpad = Controls.read()
	while true do
		pad = Controls.read()
		screen:blit(110,60,mortopts)
		if oldpad ~= pad then
			if pad:up() then mortgopts = 1 end
			if pad:down() then mortgopts = 2 end
		end
		if mortgopts == 1 then screen:blit(133,114,selector)
			if pad:cross() then Mortgage(num) end 
		end
		if mortgopts == 2 then screen:blit(133,161,selector)
			if pad:cross() then unMortgage(num) end
		end
		if pad:select() then break end
		screen.waitVblankStart()
		screen.flip()
		oldpad = pad
	end
end
----  - - - - - - - - - - - - - - - - - - - - - - - - - -
--Mortgage
function Mortgage(num)
	mortopt=1
	oldpad = Controls.read()
	while true do
		pad = Controls.read()
		screen:clear(white)
		if table.getn(deed[14 + num]) ~= 0 then
			if pad ~= oldpad then
				if pad:down() then mortopt=mortopt+1 end
				if pad:up() then  mortopt=mortopt-1 end
				if mortopt > table.getn(deed[14 + num]) then mortopt = 1 end
				if mortopt < 1 then mortopt = table.getn(deed[14 + num]) end
			end
			for i = 1, table.getn(deed[14 + num]) do
				screen:print(10,i*10,deed[12][deed[14 + num][i]],black)
			end
			if pad:cross() and oldpad:cross() ~= pad:cross() then
				playerData[1][playerMoney] = playerData[1][playerMoney]+deed[10][deed[14 + num][mortopt]]
				deed[14][deed[14 + num][mortopt]] = 3
				table.insert(deed[16 + num],deed[14 + num][mortopt])
				table.remove(deed[14 + num],mortopt)
			end
			screen:blit(3,mortopt*10+2,square)
		else
			screen:print(3,10,"No Properties to Mortgage!",black)
		end
		screen:print(3,0,"Mortgage Properties",black)
		if pad:select() then break end
		screen.waitVblankStart()
		screen.flip()
		oldpad = pad
	end
end
----  - - - - - - - - - - - - - - - - - - - - - - - - - -
--un-Mortgage
function unMortgage(num)
	mortopt=1
	oldpad = Controls.read()
	while true do
		pad = Controls.read()
		screen:clear(white)
		if table.getn(deed[16 + num]) ~= 0 then
			if pad ~= oldpad then
				if pad:down() then mortopt=mortopt+1 end
				if pad:up() then  mortopt=mortopt-1 end
				if mortopt > table.getn(deed[16 + num]) then mortopt = 1 end
				if mortopt < 1 then mortopt = table.getn(deed[16 + num]) end
			end
			for i = 1, table.getn(deed[16 + num]) do
				screen:print(10,i*10,deed[12][deed[16 + num][i]],black)
			end
			if pad:cross() and oldpad:cross() ~= pad:cross() then
				playerData[1][playerMoney] = playerData[1][playerMoney]-deed[10][deed[16 + num][mortopt]]
				deed[14][deed[16 + num][mortopt]] = 1
				table.insert(deed[14 + num],deed[16 + num][mortopt])
				table.remove(deed[16 + num],mortopt)
			end
			screen:blit(3,mortopt*10+2,square)
		else
			screen:print(3,10,"No Properties to Un-Mortgage!")
		end
		screen:print(3,0,"Un-Mortgage Properties")
		if pad:select() then break end
		screen.waitVblankStart()
		screen.flip()
		oldpad = pad
	end
end
----  - - - - - - - - - - - - - - - - - - - - - - - - - -
--Trade Deeds
function TradeDeeds(num)
	tradeopt = 1
	tradeplay = 1
	oldpad = Controls.read()
	while true do
		pad = Controls.read()
		screen:clear(white)
		if pad ~= oldpad then
			if pad:right() then tradeplay = 2 end
			if pad:left() then tradeplay = 1 end
			if pad:down() then tradeopt=tradeopt+1 end
			if pad:up() then  tradeopt=tradeopt-1 end
		end

		if table.getn(deed[15]) ~= 0 then
			if tradeplay == 1 then
				if tradeopt > table.getn(deed[15]) then tradeopt = 1 end
				if tradeopt < 1 then tradeopt = table.getn(deed[15]) end
				if pad:cross() and oldpad:cross() ~= pad:cross() then
					table.insert(deed[20],deed[15][tradeopt])
					table.remove(deed[15],tradeopt)
				end
			end
		end
		
		if table.getn(deed[16]) ~= 0 then
			if tradeplay == 2 then
				if tradeopt > table.getn(deed[16]) then tradeopt = 1 end
				if tradeopt < 1 then tradeopt = table.getn(deed[16]) end
				if pad:cross() and oldpad:cross() ~= pad:cross() then
					table.insert(deed[21],deed[16][tradeopt])
					table.remove(deed[16],tradeopt)
				end
			end
		end
		
		--Print Player 1 Deeds on Screen
		for i = 1, table.getn(deed[15]) do
			screen:print(10,i*10+10,deed[12][deed[15][i]],black)
		end
			
		--Print Player 1 to be Traded Deeds on Screen
		for iq = 1, table.getn(deed[20]) do
			if table.getn(deed[15]) > 0 then
				screen:print(10,iq * 10 + (table.getn(deed[15]) * 10 + 10),deed[12][deed[20][iq]], red)
			else
				screen:print(10,iq*10+10,deed[12][deed[20][iq]],red)
			end
		end

		--Print Player 2 Deeds on Screen
		for l = 1, table.getn(deed[16]) do
			screen:print(247,l*10+10,deed[12][deed[16][l]],black)
		end
			
		--Print Player 2 to be Traded Deeds on Screen
		for lq = 1, table.getn(deed[21]) do
			if table.getn(deed[16]) > 0 then
				screen:print(247,lq * 10 + (table.getn(deed[16]) * 10 + 10),deed[12][deed[21][lq]], red)
			else
				screen:print(247,lq*10+10,deed[12][deed[21][lq]],red)
			end
		end

		if tradeplay == 1 and table.getn(deed[15]) ~= 0 then
			screen:blit(3,tradeopt*10+12,square)
		end
		if tradeplay == 2 and table.getn(deed[16]) ~= 0 then
			screen:blit(240,tradeopt*10+12,square)
		end

		if pad:circle() then
			for g = 1, table.getn(deed[20]) do
				deed[14][deed[20][g]] = 2
				table.insert(deed[16],deed[20][g])
			end
			for r = 1, table.getn(deed[21]) do
				deed[14][deed[21][r]] = 1
				table.insert(deed[15],deed[21][r])
			end
			deed[20] = nil
			deed[21] = nil
			deed[20] = {}
			deed[21] = {}
		end

		screen:print(3,10,pname[1].."'s Properties")
		screen:print(240,10,pname[2].."'s Properties")
		screen:print(3,0,"Trade Properties -Press O to Trade and Select to Cancel")
		if pad:select() then
			for g = 1, table.getn(deed[20]) do
				table.insert(deed[15],deed[20][g])
			end
			for r = 1, table.getn(deed[21]) do
				table.insert(deed[16],deed[21][r])
			end
			deed[20] = nil
			deed[21] = nil
			deed[20] = {}
			deed[21] = {}
			break
		end
		screen.waitVblankStart()
		screen.flip()
		oldpad = pad
	-- else
		-- screen:print(3,10,"Both Players Need to Own Properties to Trade")
		-- if pad:select() then break end
		-- screen.waitVblankStart()
		-- screen.flip()
	-- end
	end
end
----  - - - - - - - - - - - - - - - - - - - - - - - - - -
--Save Game
function SaveGame()

file = io.open("savegame.mono", "w")

file:write("turnNum =" .. turnNum)

for i=1, 40 do
file:write("\ndeed[1]["..i)
file:write("]=")
file:write(deed[1][i])
end

for i=1, 40 do
file:write("\ndeed[13]["..i)
file:write("]=")
file:write(deed[13][i])
end

for i=1, 40 do
file:write("\ndeed[14]["..i)
file:write("]=")
file:write(deed[14][i])
end

if table.getn(deed[15]) ~= 0 then
	for i=1, table.getn(deed[15]) do
		file:write("\ndeed[15]["..i)
		file:write("]=")
		file:write(deed[15][i])
	end
end

if table.getn(deed[16]) ~= 0 then
	for i=1, table.getn(deed[16]) do
		file:write("\ndeed[16]["..i)
		file:write("]=")
		file:write(deed[16][i])
	end
end

if table.getn(deed[17]) ~= 0 then
	for i=1, table.getn(deed[17]) do
		file:write("\ndeed[17]["..i)
		file:write("]=")
		file:write(deed[17][i])
	end
end

if table.getn(deed[18]) ~= 0 then
	for i=1, table.getn(deed[18]) do
		file:write("\ndeed[18]["..i)
		file:write("]=")
		file:write(deed[18][i])
	end
end

file:write("\nplayerData[1][playerSquare]="..playerData[1][playerSquare])
file:write("\nplayerData[1][playerMoney]="..playerData[1][playerMoney])
file:write("\nplayerData[1][playerJail]="..playerData[1][playerJail])
file:write("\nplayerData[1][playerToken]="..playerData[1][playerToken])

file:write("\npname[1] = \""..pname[1])
file:write("\"")

file:write("\npname[2] = \""..pname[2])
file:write("\"")

file:write("\nplayerData[2][playerSquare]="..playerData[2][playerSquare])
file:write("\nplayerData[2][playerMoney]="..playerData[2][playerMoney])
file:write("\nplayerData[2][playerJail]="..playerData[2][playerJail])
file:write("\nplayerData[2][playerToken]="..playerData[2][playerToken])

file:write("\n--"..System.getFreeMemory())

file:close()

return

end
----  - - - - - - - - - - - - - - - - - - - - - - - - - -
--Quit Game
function QuitGame()
	--Credits Images
	Credits = {}
	for i = 1, 4 do
		Credits[i] = Image.load("Credits" ..i.. ".png")
	end
	--Credity Effect (Sorta)
	for i = 1, 4 do
		screen:blit(0,0,Credits[i])
		screen.flip() 
		while true do 
			screen.waitVblankStart() 
			delay(6500)
		break
		end
	end
	--Collect Garbage & Quit
	collectgarbage()
	System.Quit()
end
----  - - - - - - - - - - - - - - - - - - - - - - - - - -
--Main Game Loop

Init()
GameSplash()
Menu()
Name_Select(1)
Name_Select(2)
name = nil
collectgarbage()

message("Welcome to PSP Monopoly")
message("Your turn")

while true do
-- Input
pad = Controls.read()

--Display Chance/Community for Player 1
if even(turnNum) == false then
	if dieOne == dieTwo and deed[0][playerData[1][playerSquare]] == 2 then
		messageText1="You landed on Chance"
		messageText2="Press Cross to see"
		messageInfo="your card and continue"
		if pad:cross() then displayChance(1) end
	end

	if dieOne == dieTwo and deed[0][playerData[1][playerSquare]] == 3  then
		messageText1="You landed on Community Chest"
		messageText2="Press Cross to see"
		messageInfo="your card and continue"
		if pad:cross() then displayCommunity(1) end
	end

	if deed[0][playerData[1][playerSquare]] == 3 and dieOne ~= dieTwo then
		if pad:circle() then
			displayCommunity(1)
			turnNum=turnNum+1
			message("Player 2's turn")
			messageInfo="Its Player 2's turn"
		end
	end

	if deed[0][playerData[1][playerSquare]] == 2 and dieOne ~= dieTwo then
		if pad:circle() then
			displayChance(1)
			turnNum=turnNum+1
			message("Player 2's turn")
			messageInfo="Its Player 2's turn"
		end
	end
end

--Display Chance/Community for Player 2
if even(turnNum) == true then
	if dieOne == dieTwo and deed[0][playerData[2][playerSquare]] == 2 then
		messageText1="You landed on Chance"
		messageText2="Press Cross to see"
		messageInfo="your card and continue"
		if pad:cross() then displayChance(2) end
	end

	if dieOne == dieTwo and deed[2][playerData[2][playerSquare]] == 3  then
		messageText1="You landed on Community Chest"
		messageText2="Press Cross to see"
		messageInfo="your card and continue"
		if pad:cross() then displayCommunity(2) end
	end

	if deed[0][playerData[2][playerSquare]] == 3 and dieOne ~= dieTwo then
		if pad:circle() then
			displayCommunity(2)
			turnNum=turnNum+1
			message("Player 1's turn")
			messageInfo="Its Player 1's turn"
		end
	end

	if deed[0][playerData[2][playerSquare]] == 2 and dieOne ~= dieTwo then
		if pad:circle() then
			displayChance(2)
			turnNum=turnNum+1
			message("Player 1's turn")
			messageInfo="Its Player 1's turn"
		end
	end
end

if pad:l() and pad:r() and pad:start() then
	System.Quit()
end

if pad:note() then screen:save("screenshot.png") end

-- If turn # is an odd # then its player 1's turn

if even(turnNum) == false then
-- main code for player's turn
	if pad:cross() and rolled~=1 then	
		if playerData[1][playerJail]>0 then --If in Jail
			playerData[1][playerJail]=playerData[1][playerJail]+1
			rollDice()
			if dieOne==dieTwo then
				message("Doubles! You're free!")
				playerData[1][playerJail]=0
			else
				if playerData[1][playerJail]==4 then
					message("3rd turn, you're free.")
					playerData[1][playerJail]=0
				end
			end
			rolled=1
			messageInfo="Press Start to end your turn"
		else --If not in Jail
		rollDice()
			if dieOne==dieTwo and doubles==0 then
				movePlayer(1,dieOne+dieTwo)
				doubles=1
				message("Doubles! Roll again.")
			else
				if dieOne==dieTwo and doubles==1 and oujcomm ~=1 then
					messageInfo="Press Start to end your turn"
					message("Doubles. Go to Jail.")
					playerData[1][playerSquare]=11
					playerData[1][playerJail]=1
					rolled=1
				elseif dieOne == dieTwo and doubles == 1 and oujcomm == 1 then
					playerData[1][playerSquare]=11
					messageText1="You got a Free Card!"
					messageText2="but now its gone!"
					messageInfo="Press Start to end your turn"
					rolled=1
					oujcomm=0
				elseif dieOne == dieTwo and doubles == 1 and oujchan == 1 then
					playerData[1][playerSquare]=11
					messageText1="You got a Free Card!"
					messageText2="but now its gone!"
					messageInfo="Press Start to end your turn"
					rolled=1
					oujchan=0
				else
					movePlayer(1,dieOne+dieTwo)
					rolled=1
					messageInfo="Press Start to end your turn"
				end
			end
		end

	else 
		if pad:cross() then
			message("You've already rolled!")
			delay( 100 )
		end
	end
	
	if pad:start() and rolled==1 and deed[0][playerData[1][playerSquare]] ~= 2 and deed[0][playerData[1][playerSquare]] ~= 3 then
		turnNum=turnNum+1
		message("Player 2's turn")
		messageInfo="Its Player 2's turn"
		rolled2 = 0
		doubles2 = 0
	end
	if pad:l() and pad:r() then
		opmenu(1)
	end
end

if even(turnNum) == true then
-- else its cp's turn. all code for P2 here
	if pad:cross() and rolled2~=1 then	
		if playerData[2][playerJail]>0 then --If in Jail
			playerData[2][playerJail]=playerData[2][playerJail]+1
			rollDice()
			if dieOne==dieTwo then
				message("Doubles! You're free!")
				playerData[2][playerJail]=0
			else
				if playerData[2][playerJail]==4 then
					message("3rd turn, you're free.")
					playerData[2][playerJail]=0
				end
			end
			rolled2=1
			messageInfo="Press Start to end your turn"
		else --If not in Jail
		rollDice()
			if dieOne==dieTwo and doubles2==0 then
				movePlayer(2,dieOne+dieTwo)
				doubles2=1
				message("Doubles! Roll again.")
			else
				if dieOne==dieTwo and doubles2==1 then
					messageInfo="Press Start to end your turn"
					message("Doubles. Go to Jail.")
					playerData[2][playerSquare]=11
					playerData[2][playerJail]=1
					rolled2=1
				elseif dieOne == dieTwo and doubles2 == 1 and oujcomm == 2 then
					playerData[2][playerSquare]=11
					messageText1="You got a Free Card!"
					messageText2="but now its gone!"
					messageInfo="Press Start to end your turn"
					rolled=1
					oujcomm=0
				elseif dieOne == dieTwo and doubles2 == 1 and oujchan == 2 then
					playerData[2][playerSquare]=11
					messageText1="You got a Free Card!"
					messageText2="but now its gone!"
					messageInfo="Press Start to end your turn"
					rolled=1
					oujchan=0
				else
					movePlayer(2,dieOne+dieTwo)
					rolled2=1
					messageInfo="Press Start to end your turn"
				end
			end
		end

	else 
		if pad:cross() then
			message("You've already rolled2!")
			delay( 100 )
		end
	end

	if pad:start() and rolled2==1 and deed[0][playerData[2][playerSquare]] ~= 2 and deed[0][playerData[2][playerSquare]] ~= 3 then
		turnNum=turnNum+1
		message("Player 1's turn")
		messageInfo="Its Player 1's turn"
		rolled = 0
		doubles = 0
	end
	if pad:l() and pad:r() then
		opmenu(2)
	end
end

-- Gfx

screen:clear(black)
screen:blit(0, 0, monopoly)

screen:print(18, 85,pname[1], black) -- Your Stuff
screen:blit(3, 82, token[playerData[1][playerToken]])
screen:print(150, 85,"$"..playerData[1][playerMoney].."", black)

screen:print(18, 162,pname[2], black) -- Player 2's Stuff
screen:blit(3, 159, token[playerData[2][playerToken]])
screen:print(150, 162,"$"..playerData[2][playerMoney].."", black)

screen:blit(89,60, dice, (dieOne-1)*dieWidth, 0, dieWidth, dieHeight) -- Die 1
screen:blit(110,60, dice, (dieTwo-1)*dieWidth, 0, dieWidth, dieHeight) -- Die 2

drawMessages()
drawPieces()
displayMiniPic()
displayHouseHotel()

screen.waitVblankStart()
screen.flip()

end
